## mccode 0.0~git20240801183257.cdaa431+ds5

=== mcstas-comps/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas components
project( mcstas-comps C )

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcstas")

set(WORK "${PROJECT_BINARY_DIR}/work")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-comps-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "1.0")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, libnexus-dev, libgsl-dev, cif2hkl")

# NSIS
set(CPACK_NSIS_PACKAGE_NAME "${MCCODE_STRING} Components")
set(CPACK_NSIS_DISPLAY_NAME "${MCCODE_STRING} Components")

include(CPack)

option( ENABLE_CIF2HKL "Build Third Party code cif2hkl (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_CIF2HKL )
  enable_language( Fortran )
  add_executable(
    cif2hkl
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/cif2hkl/cif2hkl.F90
    )
  target_compile_options(cif2hkl PUBLIC "-ffree-line-length-512")
  install (
    PROGRAMS "${PROJECT_BINARY_DIR}/cif2hkl${DOT_EXE_SUFFIX}"
    DESTINATION "${DEST_BINDIR}"
    )
endif()

option( ENABLE_NEUTRONICS "Build Third Party code neutronics (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_NEUTRONICS )
  enable_language( Fortran )
  add_library(neutronics "STATIC" libs/neutronics/neutronics-subs.f)
  install(TARGETS neutronics DESTINATION "${DEST_LIBDIR}/neutronics")
  #NB (Aug 2023): Removed general "libs" which has the side-effect of not
  #installing other files related to "neutronics".
endif()

# System c-code
install( DIRECTORY "share/" DESTINATION "${DEST_DATADIR_CODEFILES}")

# Editor syntax-highlighting etc
if (NOT WINDOWS)
  file(GLOB EDITORS editors/*) # follow links (install DIRECTORY does not)
  install( FILES ${EDITORS} DESTINATION "${DEST_DATADIR_EDITORS}" )
endif()

# System comps
install( DIRECTORY "misc/"      DESTINATION "${DEST_DATADIR_COMPS}/misc")
install( DIRECTORY "monitors/"  DESTINATION "${DEST_DATADIR_COMPS}/monitors")
install( DIRECTORY "obsolete/"  DESTINATION "${DEST_DATADIR_COMPS}/obsolete")
install( DIRECTORY "optics/"    DESTINATION "${DEST_DATADIR_COMPS}/optics")
install( DIRECTORY "samples/"   DESTINATION "${DEST_DATADIR_COMPS}/samples")
install( DIRECTORY "sources/"   DESTINATION "${DEST_DATADIR_COMPS}/sources")
install( DIRECTORY "union/"     DESTINATION "${DEST_DATADIR_COMPS}/union")
install( DIRECTORY "sasmodels/" DESTINATION "${DEST_DATADIR_COMPS}/sasmodels")

# Contrib comps
if ( NOT EXCLUDE_CONTRIB )
  install( DIRECTORY "contrib/" DESTINATION "${DEST_DATADIR_COMPS}/contrib")
endif()

# Data files
if ( NOT EXCLUDE_DATA )
  install( DIRECTORY "data/"    DESTINATION "${DEST_DATADIR_COMPS}/data")
endif()

install( DIRECTORY "examples/"  DESTINATION "${DEST_DATADIR_EXAMPLES}")


# Include mcstas-comp revision tag file
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/revision.in" "${WORK}/revision" @ONLY)

# copy some descriptory files
configure_directory ("NOMENCLATURE.md" "work/nomenclature")
configure_directory ("README.md" "work/readme")
install( FILES "${WORK}/nomenclature/NOMENCLATURE.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/readme/README.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/revision" DESTINATION "${DEST_DATADIR_COMPS}" )

=== mcxtrace-comps/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McXtrace components
project( mcxtrace-comps C )

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcxtrace")

set(WORK "${PROJECT_BINARY_DIR}/work")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-comps-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "1.0")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, libnexus-dev, libxrl-dev, libgsl-dev, cif2hkl")

# NSIS
set(CPACK_NSIS_PACKAGE_NAME "${MCCODE_STRING} Components")
set(CPACK_NSIS_DISPLAY_NAME "${MCCODE_STRING} Components")

include(CPack)

option( ENABLE_CIF2HKL "Build Third Party code cif2hkl (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_CIF2HKL )
  enable_language( Fortran )
  add_executable(
    cif2hkl
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/cif2hkl/cif2hkl.F90
    )
  target_compile_options(cif2hkl PUBLIC "-ffree-line-length-512")
  install (
    PROGRAMS "${PROJECT_BINARY_DIR}/cif2hkl${DOT_EXE_SUFFIX}"
    DESTINATION "${DEST_BINDIR}"
    )
endif()

# System c-code
install( DIRECTORY "share/" DESTINATION "${DEST_DATADIR_CODEFILES}")

# Editor syntax-highlighting etc
if (NOT WINDOWS)
  file(GLOB EDITORS editors/*) # follow links (install DIRECTORY does not)
  install( FILES ${EDITORS} DESTINATION "${DEST_DATADIR_EDITORS}" )
endif()

# System comps
install( DIRECTORY "misc/"      DESTINATION "${DEST_DATADIR_COMPS}/misc")
install( DIRECTORY "monitors/"  DESTINATION "${DEST_DATADIR_COMPS}/monitors")
install( DIRECTORY "obsolete/"  DESTINATION "${DEST_DATADIR_COMPS}/obsolete")
install( DIRECTORY "optics/"    DESTINATION "${DEST_DATADIR_COMPS}/optics")
install( DIRECTORY "samples/"   DESTINATION "${DEST_DATADIR_COMPS}/samples")
install( DIRECTORY "sources/"   DESTINATION "${DEST_DATADIR_COMPS}/sources")
install( DIRECTORY "union/"     DESTINATION "${DEST_DATADIR_COMPS}/union")
install( DIRECTORY "sasmodels/" DESTINATION "${DEST_DATADIR_COMPS}/sasmodels")
install( DIRECTORY "astrox/"    DESTINATION "${DEST_DATADIR_COMPS}/astrox")

# Contrib comps
if ( NOT EXCLUDE_CONTRIB )
  install( DIRECTORY "contrib/" DESTINATION "${DEST_DATADIR_COMPS}/contrib")
endif()

# Data files
if ( NOT EXCLUDE_DATA )
  install( DIRECTORY "data/"    DESTINATION "${DEST_DATADIR_COMPS}/data")
endif()

install( DIRECTORY "examples/"  DESTINATION "${DEST_DATADIR_EXAMPLES}")


# Include mcstas-comp revision tag file
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/revision.in" "${WORK}/revision" @ONLY)

# copy some descriptory files
configure_directory ("NOMENCLATURE" "work/nomenclature")
configure_directory ("README.md" "work/readme")
install( FILES "${WORK}/nomenclature/NOMENCLATURE" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/readme/README.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/revision" DESTINATION "${DEST_DATADIR_COMPS}" )

=== tools/Python/mcplot/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

add_subdirectory(matplotlib)
add_subdirectory(pyqtgraph)
add_subdirectory(svg)

=== tools/matlab/mcdisplay/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )
cmake_policy(VERSION 3.17.0)

# This will install McStas components
project(matlab-tools-mcdisplay C)

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcxtrace.org/")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcstas.org/")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

set(TOOLS_NAME "matlab/${P}display/")
set(TOOLS_LIB  "${DEST_TOOLDIR}/${TOOLS_NAME}")

# Set some extra options for mccode_config
set(CC "${CMAKE_C_COMPILER}")
set(CFLAGS "-g -O2 -lm ${CMAKE_C_FLAGS}")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-tools-matlab-${P}display-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Matlab/octave-based mcdisplay (mcdisplay-matlab), ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}")

# RPM
set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}"
  )


include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")


# Configure fallback script
configure_file("${CMAKE_SOURCE_DIR}/mcdisplay.in" "${WORK}/${P}display" @ONLY)

# Configure doc
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcdisplay-matlab.md.in" "${WORK}/${P}display-matlab.md" @ONLY)

if(WINDOWS)
  set(BINS "${PROJECT_SOURCE_DIR}/mcdisplay.m")
else()
  set(BINS "${WORK}/${P}display")
endif()


if(WINDOWS)
  install(
    FILES ${BINS}
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )
endif()

if(NOT WINDOWS)
  install(
    FILES ${BINS}
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )

  # Symlink to main
  add_custom_command(
    OUTPUT "${WORK}/${P}display"
    COMMAND "${CMAKE_COMMAND}" -E make_directory "${WORK}"
    COMMAND "${CMAKE_COMMAND}" -E remove "${WORK}/${P}display-matlab"
    COMMAND "${CMAKE_COMMAND}" -E create_symlink
    "${TOOLS_LIB}/mcdisplay" "${WORK}/${P}display"
    )

  add_custom_target(
    "CREATE_SYMLINK" ALL DEPENDS "${WORK}/${P}display"
    )

  install(
    PROGRAMS "${WORK}/${P}display"
    DESTINATION ${DEST_BINDIR}
    RENAME "${P}display-matlab"
    )
    
  install(
    FILES "${WORK}/${P}display-matlab.md"
    DESTINATION "${DEST_DATADIR_DOC}"
  )

endif()

=== tools/matlab/mcplot/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )
cmake_policy(VERSION 3.17.0)

# This will install McStas components
project(matlab-tools-mcplot C)

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcxtrace.org/")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcstas.org/")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

set(TOOLS_NAME "matlab/${P}plot/")
set(TOOLS_LIB  "${DEST_TOOLDIR}/${TOOLS_NAME}")

# Set some extra options for mccode_config
set(CC "${CMAKE_C_COMPILER}")
set(CFLAGS "-g -O2 -lm ${CMAKE_C_FLAGS}")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-tools-matlab-${P}plot-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Matlab/octave-based mcplot (mcplot-matlab), ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}")

# RPM
set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}"
  )


include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")


# Configure fallback script
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcplot.in" "${WORK}/${P}plot" @ONLY)

# Configure doc
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcplot-matlab.md.in" "${WORK}/${P}plot-matlab.md" @ONLY)


if(WINDOWS)
  set(BINS "${PROJECT_SOURCE_DIR}/mcplot.m")
else()
  set(BINS "${WORK}/${P}plot")
endif()


if(WINDOWS)
  install(
    FILES ${BINS}
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )
endif()

if(NOT WINDOWS)
  install(
    FILES ${BINS}
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )

  # Symlink to main
  add_custom_command(
    OUTPUT "${WORK}/${P}plot"
    COMMAND "${CMAKE_COMMAND}" -E make_directory "${WORK}"
    COMMAND "${CMAKE_COMMAND}" -E remove "${WORK}/${P}plot-matlab"
    COMMAND "${CMAKE_COMMAND}" -E create_symlink
    "${TOOLS_LIB}/mcplot" "${WORK}/${P}plot"
    )

  add_custom_target(
    "CREATE_SYMLINK" ALL DEPENDS "${WORK}/${P}plot"
    )

  install(
    PROGRAMS "${WORK}/${P}plot"
    DESTINATION ${DEST_BINDIR}
    RENAME "${P}plot-matlab"
    )
    
  install(
    FILES "${WORK}/${P}plot-matlab.md"
    DESTINATION "${DEST_DATADIR_DOC}"
  )
endif()

=== tools/Python/mcdisplay/webgl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

# This will install McStas or McXtrace mc/display-webgl
project(python-tools-mcdisplay-webgl C)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcxtrace.org/")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcstas.org/")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

set(TOOLS_NAME "Python/${P}display/webgl")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-tools-python-${P}display-webgl-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Python/webgl -based ${P}display (${P}display-webgl-py), ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, python3, python3-ply, python3-numpy, nodejs")

# RPM
if (RPMPROFILE)
   if (RPMPROFILE STREQUAL "fedora")
        set(PYDEPS "python3, python3-ply, python3-numpy")
   else()
	set(PYDEPS "")
   endif()
else()
	set(PYDEPS "")
endif()

set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION},  ${PYDEPS}"
)

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

# Configure fallback script
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcdisplay.in" "${WORK}/${P}display" @ONLY)

# Put package.json in $WORK
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/package.json" "${WORK}/package.json" @ONLY)

# Create folder for node_modules later installed by npm
execute_process(COMMAND "mkdir" "node_modules"
  WORKING_DIRECTORY "${WORK}")

# Dist
install(
  DIRECTORY "${PROJECT_SOURCE_DIR}/dist"
  DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
  )


# Node modules
install(
    DIRECTORY "${WORK}/node_modules"
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    )

# Main script, including rename mc/mxdisplay
install(
        PROGRAMS "${PROJECT_SOURCE_DIR}/mcdisplay.py"
        DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
        RENAME "${P}display.py"
    )

# Other .py infrastructure
foreach(NAME start-vite.js package.json mcdisplay.js Lut.js OrbitControls.js dat.gui.min.js jquery.min.js three.min.js template.html __init__.py)
  install(
    FILES "${PROJECT_SOURCE_DIR}/${NAME}"
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    )
endforeach()

# Wrapper-scripts on windows are handled via
# cmake Modules/MCUtil
if(NOT WINDOWS)
  install(
    PROGRAMS ${PROJECT_SOURCE_DIR}/mcdisplay.py
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    RENAME "${P}display.py"
  )

  install(
    PROGRAMS "${WORK}/${P}display"
    DESTINATION ${DEST_BINDIR}
    RENAME "${P}display-webgl"
    )
endif()

# Script for npm instal during install part
if (NOT WINDOWS)
  # Configure fallback script
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/npminstall.in" "${WORK}/npminstall" @ONLY)
  install(
    PROGRAMS "${WORK}/npminstall"
    DESTINATION ${DEST_TOOLDIR}/${TOOLS_NAME}
  )
  install(CODE "execute_process(COMMAND \"${CMAKE_INSTALL_PREFIX}/${DEST_TOOLDIR}/${TOOLS_NAME}/npminstall\")")
else()
  # Configure fallback script
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/npminstall.bat.in" "${WORK}/npminstall.bat" @ONLY)
  install(
    PROGRAMS "${WORK}/npminstall.bat"
    DESTINATION ${DEST_TOOLDIR}/${TOOLS_NAME}
  )
  install(CODE "execute_process(COMMAND \"${CMAKE_INSTALL_PREFIX}/${DEST_TOOLDIR}/${TOOLS_NAME}/npminstall.bat\")")
endif()

=== tools/Python/mcplot/svg/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

# This will install McStas or McXtrace mc/mxplot-pyqtgraph
project(python-tools-mcplot-svg C)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcxtrace.org/")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcstas.org/")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

set(TOOLS_NAME "Python/${P}plot/svg")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-tools-python-${P}plot-svg-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Python-based mcplot (mcplot-svg-py), ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, python3-scipy, python3-pillow, python3-numpy")

# RPM
if (RPMPROFILE)
   if (RPMPROFILE STREQUAL "fedora")
        set(PYDEPS " python3-scipy, python3-pillow, python3-numpy")
   else()
	set(PYDEPS "")
   endif()
else()
	set(PYDEPS "")
endif()

set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}, ${PYDEPS}"
)

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

# Configure fallback script
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcplot.in" "${WORK}/${P}plot-svg" @ONLY)

# Configure doc
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcplot-svg.md.in" "${WORK}/${P}plot-svg.md" @ONLY)

# Main script, including rename mc/mxplot
install(
  PROGRAMS "${PROJECT_SOURCE_DIR}/mcplot.py"
  DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
  RENAME "${P}plot.py"
  )

# Other .py infrastructure
foreach(NAME d3.v4.min.js template_1d.html template_2d.html plotfuncs.js)
  install(
    FILES "${PROJECT_SOURCE_DIR}/${NAME}"
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    )
endforeach()

# Wrapper-scripts on windows are handled via
# cmake Modules/MCUtil
if(NOT WINDOWS)
  add_custom_target(
    "CREATE_${PROJECT_NAME}_SYMLINK" ALL DEPENDS "${WORK}/${P}plot-svg"
    )

  install(
    PROGRAMS ${PROJECT_SOURCE_DIR}/mcplot.py
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    RENAME "${P}plot.py"
  )

  install(
    PROGRAMS "${WORK}/${P}plot-svg"
    DESTINATION ${DEST_BINDIR}
    )
    
  install(
    FILES "${WORK}/${P}plot-svg.md"
    DESTINATION "${DEST_DATADIR_DOC}"
  )
  
endif()

=== debian/changelog ===
mccode (0.0~git20240801183257.cdaa431+ds5-2) unstable; urgency=medium

  * Bug fix: "please make the build (mostly) reproducible", thanks to
    Chris Lamb (Closes: #1076507) (part of the patch was not needed due to
    upstream changes).

 -- Roland Mas <lolando@debian.org>  Tue, 06 Aug 2024 16:08:22 +0200

mccode (0.0~git20240801183257.cdaa431+ds5-1) unstable; urgency=medium

  * Team upload

  [ Emmanuel FARHI ]
  * Adapt patches to new upstream git HEAD
  * Add man pages and solve many lintian warnings
  * replace doc postinst generation by static generation in d/rules.
  * Bug fix: "ftbfs with GCC-14", thanks to Matthias Klose (Closes:
    #1075261).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 02 Aug 2024 15:21:12 +0200

mccode (0.0~git20240719135548.728fd5e+ds5-1) unstable; urgency=medium

  * Team upload

  [ Emmanuel FARHI ]
  * debian: add webgl-classic 3d viewer, fix doc generation (postinst is needed)
  * debian: update release number
  * debian: fix duplicate links
  * debian: add patch to install common/lib/share

  [ Picca Frédéric-Emmanuel ]
  * Trim trailing whitespace.
  * New upstream version 0.0~git20240719135548.728fd5e+ds5
  * d/patches: refresh patch series

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 19 Jul 2024 17:18:51 +0200

=== debian/control ===
Source: mccode
Section: science
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Roland Mas <lolando@debian.org>,
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 dh-cmake,
 dh-python,
 flex,
 gfortran,
 pandoc,
 python3-all,
 recode,
Standards-Version: 4.6.2
Homepage: https://github.com/McStasMcXtrace/McCode
Vcs-Browser: https://salsa.debian.org/science-team/mccode
Vcs-Git: https://salsa.debian.org/science-team/mccode.git
Rules-Requires-Root: no

# mcstas base packages ---------------------------------------------------------

Package: mcstas
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Neutron ray-trace simulation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas engine itself.

Package: mcstas-comps
Architecture: any
Depends:
 cif2hkl,
 libgsl-dev,
 libmcpl-dev,
 mcpl,
 mcstas,
 ${misc:Depends},
Description: Neutron ray-trace simulation - components
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas components (i.e. models for
 simulated instruments and objects).

Package: mcstas-mccodelib
Architecture: any
Depends:
 gedit,
 mcstas,
 mcstas-comps,
 python3,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - Python code library
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains Python libraries.

Package: mcstas-mcdoc
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - documentation browser
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains mcdoc, a tool to display documentation for
 McStas itself and for the simulated instruments.

Package: mcstas-manuals
Architecture: any
Depends:
 mcstas-mcdoc,
 ${misc:Depends},
Description: Neutron ray-trace simulation - documentation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the documentation.

Package: mcstas-mcrun
Architecture: any
Depends:
 gcc,
 mcstas-manuals,
 mcstas-mccodelib,
 python3,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - runner
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains mcrun, the command-line tool to run the
 McStat simulations.

Package: mcstas-mcgui
Architecture: any
Depends:
 mcstas-mcrun,
 python3,
 python3-pyqt5,
 python3-pyqt5.qsci,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - GUI
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the graphical user interface.

Package: mcstas-clusterscripts
Architecture: any
Depends:
 mcstas-mcrun,
 ${misc:Depends},
 ${perl:Depends},
Description: Neutron ray-trace simulation - parallelization scripts
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains scripts to run McStas in parallel on various
 types of clusters.

# mcstas plot tools ------------------------------------------------------------

Package: mcstas-mcplot-pyqtgraph
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-pyqtgraph,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - pyqtgraph plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph plotting frontend for the
 simulation results.

Package: mcstas-mcplot-matplotlib
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-matplotlib,
 ${misc:Depends},
Description: Neutron ray-trace simulation - Matplotlib plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the Matplotlib plotting frontend for the
 simulation results.

Package: mcstas-mcplot-svg
Architecture: any
Depends:
 libjs-d3,
 mcstas-mccodelib,
 python3,
 ${misc:Depends},
Description: Neutron ray-trace simulation - SVG plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the SVG plotting frontend for the
 simulation results.

Package: mcstas-mcplot-matlab
Architecture: any
Depends:
 mcstas-mccodelib,
 octave,
 ${misc:Depends},
Description: Neutron ray-trace simulation - Matlab/Octave plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains a Matlab/Octave frontend for the simulation
 result viewer.

# mcstas display tools ---------------------------------------------------------

Package: mcstas-mcdisplay-pyqtgraph
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-pyqtgraph,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - pyqtgraph instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph frontend for the instrument
 display.

Package: mcstas-mcdisplay-webgl
Architecture: any
Depends:
 libjs-three,
 mcstas-mccodelib,
 python3,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - WebGL instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# INSTALL_PREFIX=/usr/share
INSTALL_PREFIX=/usr/
MCCODE_VERSION=3
MCVERSION=3
MCSTAS_VERSION=3.5
MCXTRACE_VERSION=3.5

# WARNING: the MCCODE_USE_LEGACY_DESTINATIONS=OFF changes the legacy tools/library destination to 'resources'
CMAKE_ARGS=-DMCCODE_VERSION=$(MCCODE_VERSION) -DCMAKE_INSTALL_PREFIX=$(INSTALL_PREFIX) \
  -DMCCODE_USE_LEGACY_DESTINATIONS=OFF -DENABLE_CIF2HKL=OFF
CMAKE_ARGS_N=-Denable_mcstas=1   -DBUILD_MCSTAS=1   $(CMAKE_ARGS) -DMCVERSION=$(MCSTAS_VERSION)
CMAKE_ARGS_X=-Denable_mcxtrace=1 -DBUILD_MCXTRACE=1 $(CMAKE_ARGS) -DMCVERSION=$(MCXTRACE_VERSION)

PARALLEL=$(shell echo $DEB_BUILD_OPTIONS|xargs -n 1|grep ^parallel=|cut -d= -f2)
ifneq ($(strip $(PARALLEL)),)
	MAKE_ARGS=-j$(PARALLEL)
endif

# compile function: mccode_compile_N $pkg $src_cmake_dir
define mccode_compile_N
	# compile $(2)
	mkdir -p BUILD/$(1) && cd BUILD/$(1) && cmake $(CMAKE_ARGS_N) $(CURDIR)/$(2) && make $(MAKE_ARGS)
endef

# compile function: mccode_compile_X $pkg $src_cmake_dir
define mccode_compile_X
	# compile $(2)
	mkdir -p BUILD/$(1) && cd BUILD/$(1) && cmake $(CMAKE_ARGS_X) $(CURDIR)/$(2) && make $(MAKE_ARGS)
endef

# install function: mccode_install $pkg
define mccode_install
	# installing $(1)
	cd BUILD/$(1) && make install DESTDIR=$(CURDIR)/debian/$(1)
	# install: make executables for $(1)
	if [ -d $(CURDIR)/debian/$(1)/usr/bin ]; then \
	  chmod +x $(CURDIR)/debian/$(1)/usr/bin/*; fi
	# create man pages for $(1) if any
	for i in $$(ls $(CURDIR)/debian/$(1)/usr/share/doc/mcstas/*.md \
	  $(CURDIR)/debian/$(1)/usr/share/doc/mcxtrace/*.md); do \
	    mkdir -p $(CURDIR)/debian/$(1)/usr/share/man/man1/; \
	    bn=$$(basename -s .md $$i); \
	    pandoc --standalone --to man $$i -o $(CURDIR)/debian/$(1)/usr/share/man/man1/$${bn}.1; \
	done
endef

%:
	dh $@ --with cmake

execute_after_dh_auto_clean:
	rm -f cmake/Modules/debian.cmake

override_dh_auto_configure:

override_dh_auto_build:
	mkdir -p BUILD
	cp cmake/toolchains/deb64.cmake cmake/Modules/debian.cmake
	sed -i -e /amd64/d -e/CMAKE_SYSTEM_NAME/d cmake/Modules/debian.cmake

	# Performing mcstas build
	$(call mccode_compile_N,mcstas,mcstas)

	$(call mccode_compile_N,mcstas-comps,mcstas-comps)
	$(call mccode_compile_N,mcstas-mccodelib,tools/Python/mccodelib/)
	$(call mccode_compile_N,mcstas-mcdoc,tools/Python/mcdoc)
	$(call mccode_compile_N,mcstas-manuals,docpkg/manuals/mcstas)
	$(call mccode_compile_N,mcstas-mcrun,tools/Python/mcrun)
	$(call mccode_compile_N,mcstas-mcgui,tools/Python/mcgui)
	$(call mccode_compile_N,mcstas-clusterscripts,tools/cluster-scripts)

	$(call mccode_compile_N,mcstas-mcplot-pyqtgraph,tools/Python/mcplot/pyqtgraph)
	$(call mccode_compile_N,mcstas-mcplot-matplotlib,tools/Python/mcplot/matplotlib)
	$(call mccode_compile_N,mcstas-mcplot-svg,tools/Python/mcplot/svg)
	$(call mccode_compile_N,mcstas-mcplot-matlab,tools/matlab/mcplot)

	$(call mccode_compile_N,mcstas-mcdisplay-webgl,tools/Python/mcdisplay/webgl)
	$(call mccode_compile_N,mcstas-mcdisplay-webgl-classic,tools/Python/mcdisplay/webgl-classic)
	$(call mccode_compile_N,mcstas-mcdisplay-pyqtgraph,tools/Python/mcdisplay/pyqtgraph)
	$(call mccode_compile_N,mcstas-mcdisplay-matplotlib,tools/Python/mcdisplay/matplotlib/)
	$(call mccode_compile_N,mcstas-mcdisplay-matlab,tools/matlab/mcdisplay)

	$(call mccode_compile_N,mcstas-mcdisplay-mantid,tools/Python/mcdisplay/mantid_xml)
	$(call mccode_compile_N,mcstas-mcresplot,tools/Python/mcresplot)

	# Performing mcxtrace build
	$(call mccode_compile_X,mcxtrace,mcxtrace)

	$(call mccode_compile_X,mcxtrace-comps,mcxtrace-comps)
	$(call mccode_compile_X,mcxtrace-mccodelib,tools/Python/mccodelib)
	$(call mccode_compile_X,mcxtrace-mxrun,tools/Python/mcrun)
	$(call mccode_compile_X,mcxtrace-mxgui,tools/Python/mcgui)
	$(call mccode_compile_X,mcxtrace-clusterscripts,tools/cluster-scripts)
	$(call mccode_compile_X,mcxtrace-mxdoc,tools/Python/mcdoc)
	$(call mccode_compile_X,mcxtrace-manuals,docpkg/manuals/mcxtrace)

	$(call mccode_compile_X,mcxtrace-mxplot-pyqtgraph,tools/Python/mcplot/pyqtgraph)
	$(call mccode_compile_X,mcxtrace-mxplot-matplotlib,tools/Python/mcplot/matplotlib)
	$(call mccode_compile_X,mcxtrace-mxplot-svg,tools/Python/mcplot/svg)
	$(call mccode_compile_X,mcxtrace-mxplot-matlab,tools/matlab/mcplot)

	$(call mccode_compile_X,mcxtrace-mxdisplay-webgl,tools/Python/mcdisplay/webgl)
	$(call mccode_compile_X,mcxtrace-mxdisplay-webgl-classic,tools/Python/mcdisplay/webgl-classic)
	$(call mccode_compile_X,mcxtrace-mxdisplay-pyqtgraph,tools/Python/mcdisplay/pyqtgraph)
	$(call mccode_compile_X,mcxtrace-mxdisplay-matplotlib,tools/Python/mcdisplay/matplotlib/)
	$(call mccode_compile_X,mcxtrace-mxdisplay-matlab,tools/matlab/mcdisplay)


execute_before_dh_auto_install:
	# Performing mcstas install in packages
	$(call mccode_install,mcstas)

	$(call mccode_install,mcstas-comps)
	$(call mccode_install,mcstas-mccodelib)
	$(call mccode_install,mcstas-mcdoc)
	$(call mccode_install,mcstas-manuals)
	$(call mccode_install,mcstas-mcrun)
	$(call mccode_install,mcstas-mcgui)
	$(call mccode_install,mcstas-clusterscripts)
	$(call mccode_install,mcstas-mcplot-pyqtgraph)
	$(call mccode_install,mcstas-mcplot-matplotlib)
	$(call mccode_install,mcstas-mcplot-matlab)
	$(call mccode_install,mcstas-mcplot-svg)
	$(call mccode_install,mcstas-mcdisplay-webgl)
	$(call mccode_install,mcstas-mcdisplay-webgl-classic)
	$(call mccode_install,mcstas-mcdisplay-pyqtgraph)
	$(call mccode_install,mcstas-mcdisplay-matplotlib)
	$(call mccode_install,mcstas-mcdisplay-mantid)
	$(call mccode_install,mcstas-mcdisplay-matlab)
	$(call mccode_install,mcstas-mcresplot)
	# Ignored: (mcstas-ncrystal)

	# Performing mcxtrace install in packages
	$(call mccode_install,mcxtrace)

	$(call mccode_install,mcxtrace-comps)
	$(call mccode_install,mcxtrace-mccodelib)
	$(call mccode_install,mcxtrace-clusterscripts)
	$(call mccode_install,mcxtrace-manuals)
	$(call mccode_install,mcxtrace-mxdoc)
	$(call mccode_install,mcxtrace-mxrun)
	$(call mccode_install,mcxtrace-mxgui)
	$(call mccode_install,mcxtrace-mxplot-matplotlib)
	$(call mccode_install,mcxtrace-mxplot-pyqtgraph)
	$(call mccode_install,mcxtrace-mxplot-svg)
	$(call mccode_install,mcxtrace-mxplot-matlab)
	$(call mccode_install,mcxtrace-mxdisplay-webgl)
	$(call mccode_install,mcxtrace-mxdisplay-webgl-classic)
	$(call mccode_install,mcxtrace-mxdisplay-pyqtgraph)
	$(call mccode_install,mcxtrace-mxdisplay-matplotlib)
	$(call mccode_install,mcxtrace-mxdisplay-matlab)

	# Replace symlinks with the files they point to
	for i in $$(awk '/^Package:/ { print $$2 }' debian/control) ; do\
	  find debian/$$i -type l -print0 | xargs -r  -0 sed -i -e '' ; \
	done

execute_after_dh_auto_install:
	# avoid conflicts and lintian warnings
	mv debian/mcstas/usr/share/mcstas/mcstas-environment        debian/mcstas/usr/bin/
	mv debian/mcxtrace/usr/share/mcxtrace/mcxtrace-environment  debian/mcxtrace/usr/bin/
	chmod +x debian/mcxtrace-comps/usr/share/mcxtrace/resources/data/get_xray_db_data

	# module files
	mkdir -p debian/mcxtrace/etc/modulefiles
	mkdir -p debian/mcstas/etc/modulefiles
	mv debian/mcxtrace/usr/share/mcxtrace/mcxtrace-module debian/mcxtrace/etc/modulefiles/
	mv debian/mcstas/usr/share/mcstas/mcstas-module       debian/mcstas/etc/modulefiles/
	chmod -x debian/mcxtrace/etc/modulefiles/* debian/mcstas/etc/modulefiles/*

	# reproducible build
	find debian -name mccode_config.json -print0 | xargs -0rt sed -i -e "s@$(CURDIR)@/builddir@g"

	# add editor highlight syntaxing
	mkdir -p debian/mcstas-comps/usr/share/gtksourceview-4/language-specs/
	mkdir -p debian/mcxtrace-comps/usr/share/gtksourceview-4/language-specs/
	ln -s /usr/share/mcstas/editors/mccode.lang   debian/mcstas-comps/usr/share/gtksourceview-4/language-specs/mcstas.lang
	ln -s /usr/share/mcxtrace/editors/mccode.lang debian/mcxtrace-comps/usr/share/gtksourceview-4/language-specs/mcxtrace.lang

	# Remove JavaScript files as will use those from system

=== debian/watch ===
version=4
opts="mode=git, repack, repacksuffix=+ds5, date=%Y%m%d%H%M%S, dversionmangle=s/\+ds\d+//, pgpmode=none" \
https://github.com/McStasMcXtrace/McCode.git HEAD
